package org.greenstone.gsdl3_extension.mat;

import java.awt.*;
import java.awt.event.*;
import java.awt.Dimension;
import java.awt.Component;
import javax.swing.*;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

public class SummaryPanel extends JPanel {
    
    MetadataStats ms_stats;
    DataMaker data_Maker ;
    ArrayList metadataNameList;
    
    final int label_width = 320;
    final int label_width1 = 200;
    final int label_height = 30;
    final int label_x_1 = 50;
    final int label_x_2 = 325;
    final int label_font_size = 16;
    
    private int totalMetadataItem = 0;
    private int totalDocument = 0;
    private int totalMetadataElement = 0;

    private HashMap jListDataModel = new HashMap();
    
    public SummaryPanel(MetadataStats arg1) {
    	
    	ms_stats = arg1;
    	data_Maker = new DataMaker(ms_stats);
    	metadataNameList = arg1.metadataNameList;
    	totalDocument = data_Maker.getTotalDocNumber();
    	calculateTotalMetadataItem();
    	
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    private void calculateTotalMetadataItem(){
    	
    	HashMap setMap = ms_stats.getMetadataSetMap();
    	Collection c = setMap.values();
    	Iterator i = c.iterator();
    	
    	while(i.hasNext()){
    		MetadataSet mt = (MetadataSet) i.next();
    		totalMetadataElement = totalMetadataElement + mt.getIndexsList().size();
    	}
    	totalMetadataItem = totalMetadataElement *totalDocument;
    }
    
    private void jbInit() throws Exception {
  
        JTabbedPane tabbedPane = new JTabbedPane();
        data_Maker.setTotalDocNumber();
  
        elements = new String [metadataNameList.size()];
	
        for(int i = 0; i<elements.length; i++){
        	elements[i] = (String)metadataNameList.get(i);
        }
	
        Arrays.sort(elements);
        jComboBox1 = new JComboBox(elements);
        jComboBox2 = new JComboBox(sortOptions);
        
        HashMap mdsMap = ms_stats.getMetadataSetMap();
        MDS_list = new String[mdsMap.size()];
        int counter = 0;
        Set set_key = mdsMap.keySet();
        Iterator i = set_key.iterator();
        
        while(i.hasNext()){
        	MDS_list[counter] = (String) i.next();
        	counter++;
        }
  
        jComboBox3 = new JComboBox(MDS_list);
        
        JComponent panel1 = new JPanel();
        panel1.setLayout(new AbsoluteLayout());
       
        jLabel27.setText("Number of Documents : ");
        jLabel27.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 16));
        
        jLabel28.setText("Number of Metadata Set : ");
        jLabel28.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 16));
        
        jLabel29.setText("Overall Completeness : ");
        jLabel29.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 16));
        
        jLabel30.setText("Date of Build : ");
        jLabel30.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 16));
        
        jLabel35.setText(" ");
        jLabel35.setHorizontalAlignment(JLabel.CENTER);
        jLabel35.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 16));
        
        jLabel36.setText(" ");
        jLabel36.setHorizontalAlignment(JLabel.CENTER);
        jLabel36.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 16));
        
        jLabel37.setText(" ");
        jLabel37.setHorizontalAlignment(JLabel.CENTER);
        jLabel37.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 16));
        
        jLabel38.setText(" ");
        jLabel38.setHorizontalAlignment(JLabel.CENTER);
        jLabel38.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 16));
        
        jLabel39.setText("Hide Empty Metadata Element");
        jLabel39.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 12));
        
        jLabel40.setText("Hide Completed Metadata Element ");
        jLabel40.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 12));
        
        jLabel41.setText("Hide Document with empty metadata element set");
        jLabel41.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 12));
       
        jLabel42.setText("Hide Document with completed metadata element set");
        jLabel42.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 12));
        
        jButton1.setText("Indexes");
        jButton1.setPreferredSize(new Dimension(150,20));
        
        
        ActionListener doIt1 = new ActionListener() {
		public void actionPerformed(ActionEvent ae) {
		    jButton1_actionPerformed(ae);
		}
	    };
	
	    ActionListener cursorDoIt1 = CursorController.createListener(this, doIt1);
	    jButton1.addActionListener(cursorDoIt1);
	
        jLabel31.setText("Metadata Set completeness");
        jLabel31.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 16));
        
        jButton8.setText("Table");
        jButton8.setPreferredSize(new Dimension(150,20));
        jButton8.setBorder(BorderFactory.createLineBorder(Color.DARK_GRAY));
        
        ActionListener doIt8 = new ActionListener() {
		public void actionPerformed(ActionEvent ae) {
		    jButton8_actionPerformed(ae);
		}
	    };
	
	    ActionListener cursorDoIt8 = CursorController.createListener(this, doIt8);
	    jButton8.addActionListener(cursorDoIt8);
        
        jButton9.setText("Customise");
        jButton9.setPreferredSize(new Dimension(200,20));
        jButton9.setBorder(BorderFactory.createLineBorder(Color.DARK_GRAY));
        
        ActionListener doIt9 = new ActionListener() {
		public void actionPerformed(ActionEvent ae) {
		    jButton9_actionPerformed(ae);
		}
	    };
	
	    ActionListener cursorDoIt9 = CursorController.createListener(this, doIt9);
	    jButton9.addActionListener(cursorDoIt9);

	    /*
        jButton11.setText("Web pages");
        jButton11.setPreferredSize(new Dimension(150,20));
        jButton11.setBorder(BorderFactory.createLineBorder(Color.DARK_GRAY));
        jButton11.addActionListener(new SummaryPanel_jButton11_Adapter(this));
        
		ActionListener doIt11 = new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
			jButton11_actionPerformed(ae);
			}
        };
	
        ActionListener cursorDoIt11 = CursorController.createListener(this, doIt11);
		jButton11.addActionListener(cursorDoIt11);
	     */

        jList1 = new JList();
        jCheckBox1 = new JCheckBox();
        jCheckBox2 = new JCheckBox();
        jCheckBox3 = new JCheckBox();
        jCheckBox4 = new JCheckBox();
        
        jList1.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 16));
 
        JPanel panel4 = new JPanel();
        panel4.setLayout(new AbsoluteLayout());
        panel4.setBorder(BorderFactory.createLineBorder(Color.black));
        panel4.add(jLabel39,new AbsoluteConstraints(35,5,400,label_height));
        panel4.add(jLabel40,new AbsoluteConstraints(35,40,400,label_height));
        panel4.add(jLabel41,new AbsoluteConstraints(35,75,400,label_height));
        panel4.add(jLabel42,new AbsoluteConstraints(35,110,400,label_height));
        
        panel4.add(jCheckBox1,new AbsoluteConstraints(10,7,20,20));
        panel4.add(jCheckBox2,new AbsoluteConstraints(10,42,20,20));
        panel4.add(jCheckBox3,new AbsoluteConstraints(10,77,20,20));
        panel4.add(jCheckBox4,new AbsoluteConstraints(10,112,20,20));
        panel4.add(jButton9, new AbsoluteConstraints(20,145,100,30));

        panel1.add(jButton1,new AbsoluteConstraints(50,650,100,30));
        panel1.add(jButton8,new AbsoluteConstraints(160,650,100,30));
        //panel1.add(jButton9,new AbsoluteConstraints(270,650,100,30));
        //panel1.add(jButton11,new AbsoluteConstraints(380,650,100,30));
        
        panel1.add(jLabel27, new AbsoluteConstraints(label_x_1, 20, label_width, label_height));
        panel1.add(jLabel28, new AbsoluteConstraints(label_x_1, 55, label_width, label_height));
        panel1.add(jLabel29, new AbsoluteConstraints(label_x_1, 90, label_width, label_height));

        panel1.add(jLabel31, new AbsoluteConstraints(label_x_1, 160, label_width, label_height));
        panel1.add(jLabel35, new AbsoluteConstraints(label_x_2, 20, label_width1, label_height));
        panel1.add(jLabel36, new AbsoluteConstraints(label_x_2, 55, label_width1, label_height));
        panel1.add(jLabel37, new AbsoluteConstraints(label_x_2, 90, label_width1, label_height));
        panel1.add(new JScrollPane(jList1), new AbsoluteConstraints(label_x_1, 200, 450, 200));
        panel1.add(panel4, new AbsoluteConstraints(label_x_1, 410, 450, 180));

        
        //------------------------SECOND PANEL ---------------------------
        jComboBox1.addItemListener(new SummaryPanel_jComboBox1_itemAdapter(this));
        jComboBox1.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 16));
        
        jComboBox2.addItemListener(new SummaryPanel_jComboBox2_itemAdapter(this));
        jComboBox2.setFont(new java.awt.Font("Sans-serif", Font.BOLD, label_font_size));
        
        JComponent panel2 = new JPanel();
        panel2.setLayout(new AbsoluteLayout());

        jLabel1.setText("Metadata : ");
        jLabel1.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 16));
        
        jLabel2.setText("Unique Value : ");
        jLabel2.setFont(new java.awt.Font("Sans-serif", Font.BOLD, label_font_size));    
  
        jLabel3.setText(" ");
        jLabel3.setHorizontalAlignment(JLabel.CENTER);
  
        jLabel4.setText("Total times element used :");
        jLabel4.setFont(new java.awt.Font("Sans-serif", Font.BOLD, label_font_size));
        
        jLabel5.setText(" ");
        jLabel5.setHorizontalAlignment(JLabel.CENTER);
        
        jLabel6.setText("No. of records containing element :");
        jLabel6.setFont(new java.awt.Font("Sans-serif", Font.BOLD, label_font_size));
        
        jLabel7.setText(" ");
        jLabel7.setHorizontalAlignment(JLabel.CENTER);
        
        jLabel8.setText("Completeness %:");
        jLabel8.setFont(new java.awt.Font("Sans-serif", Font.BOLD, label_font_size));
        
        jLabel9.setText(" ");
        jLabel9.setHorizontalAlignment(JLabel.CENTER);
        
        jLabel10.setText("Median : ");
        jLabel10.setFont(new java.awt.Font("Sans-serif", Font.BOLD, label_font_size));
        
        jLabel11.setText(" ");
        jLabel11.setHorizontalAlignment(JLabel.CENTER);
        
        jLabel12.setText("Smallest number : ");
        jLabel12.setFont(new java.awt.Font("Sans-serif", Font.BOLD, label_font_size));
        
        jLabel13.setText(" ");
        jLabel13.setHorizontalAlignment(JLabel.CENTER);
        
        jLabel14.setText("Largest number : ");
        jLabel14.setFont(new java.awt.Font("Sans-serif", Font.BOLD, label_font_size));
        
        jLabel15.setText(" ");
        jLabel15.setHorizontalAlignment(JLabel.CENTER);
        
        jLabel16.setText("Average : ");
        jLabel16.setFont(new java.awt.Font("Sans-serif", Font.BOLD, label_font_size));
        
        jLabel17.setText(" ");
        jLabel17.setHorizontalAlignment(JLabel.CENTER);
        
        jLabel18.setText("Mode : ");
        jLabel18.setFont(new java.awt.Font("Sans-serif", Font.BOLD, label_font_size));
        
        jLabel19.setText(" ");
        jLabel19.setHorizontalAlignment(JLabel.CENTER);
        
        jLabel20.setText("Mode Frequency : ");
        jLabel20.setFont(new java.awt.Font("Sans-serif", Font.BOLD, label_font_size));
        
        jLabel21.setText(" ");
        jLabel21.setHorizontalAlignment(JLabel.CENTER);
        
        jLabel22.setText("Choose a sorting method : ");
        jLabel22.setFont(new java.awt.Font("Sans-serif", Font.BOLD, label_font_size));
        
        jLabel23.setText("First Five :");
        jLabel23.setFont(new java.awt.Font("Sans-serif", Font.BOLD, label_font_size));

        jLabel24.setText(" ");   
        jLabel24.setBorder(BorderFactory.createLineBorder(Color.black));
        
        jLabel25.setText("Last Five :");
        jLabel25.setFont(new java.awt.Font("Sans-serif", Font.BOLD, label_font_size));

        jLabel26.setText(" ");
        jLabel26.setBorder(BorderFactory.createLineBorder(Color.black));
              
        jTextPane1.setSize(new Dimension(150,200));
        jTextPane1.setOpaque(false);
        jTextPane1.setAutoscrolls(true);
        
        jTextPane2.setSize(new Dimension(150,200));
        jTextPane2.setAutoscrolls(true);
        jTextPane2.setOpaque(false);
        
        jButton2.setText("Frequency chart1");
        jButton2.setBorder(BorderFactory.createLineBorder(Color.DARK_GRAY));
        ActionListener doIt2 = new ActionListener() {
        	public void actionPerformed(ActionEvent ae) {
        		jButton2_actionPerformed(ae);
        	}
	    };
	
	    ActionListener cursorDoIt2 = CursorController.createListener(this, doIt2);
	    jButton2.addActionListener(cursorDoIt2);
        
        jButton3.setText("Frequency chart2");
        jButton3.setBorder(BorderFactory.createLineBorder(Color.DARK_GRAY));
        ActionListener doIt3 = new ActionListener() {
        	public void actionPerformed(ActionEvent ae) {
        		jButton3_actionPerformed(ae);
        	}
	    };
	
	    ActionListener cursorDoIt3 = CursorController.createListener(this, doIt3);
	    jButton3.addActionListener(cursorDoIt3);
        
	    panel2.add(jLabel1, new AbsoluteConstraints(label_x_1, 20, label_width, label_height));
        panel2.add(jComboBox1, new AbsoluteConstraints(label_x_2, 20, label_width1, label_height));
        panel2.add(jLabel2, new AbsoluteConstraints(label_x_1, 55, label_width, label_height));
        panel2.add(jLabel3, new AbsoluteConstraints(label_x_2, 55, label_width1, label_height));
        panel2.add(jLabel4, new AbsoluteConstraints(label_x_1, 90, label_width, label_height));
        panel2.add(jLabel5, new AbsoluteConstraints(label_x_2, 90, label_width1, label_height));
        panel2.add(jLabel6, new AbsoluteConstraints(label_x_1, 125, label_width, label_height));
        panel2.add(jLabel7, new AbsoluteConstraints(label_x_2, 125, label_width1, label_height));
        panel2.add(jLabel8, new AbsoluteConstraints(label_x_1, 160, label_width, label_height));
        panel2.add(jLabel9, new AbsoluteConstraints(label_x_2, 160, label_width1, label_height));
        panel2.add(jLabel10, new AbsoluteConstraints(label_x_1, 195, label_width, label_height));
        panel2.add(jLabel11, new AbsoluteConstraints(label_x_2, 195, label_width1, label_height));
        panel2.add(jLabel12, new AbsoluteConstraints(label_x_1, 230, label_width, label_height));
        panel2.add(jLabel13, new AbsoluteConstraints(label_x_2, 230, label_width1, label_height));
        panel2.add(jLabel14, new AbsoluteConstraints(label_x_1, 265, label_width, label_height));
        panel2.add(jLabel15, new AbsoluteConstraints(label_x_2, 265, label_width1, label_height));
        panel2.add(jLabel16, new AbsoluteConstraints(label_x_1, 300, label_width, label_height));
        panel2.add(jLabel17, new AbsoluteConstraints(label_x_2, 300, label_width1, label_height));
        panel2.add(jLabel18, new AbsoluteConstraints(label_x_1, 335, label_width, label_height));
        panel2.add(jLabel19, new AbsoluteConstraints(label_x_2, 335, label_width1, label_height));
        panel2.add(jLabel20, new AbsoluteConstraints(label_x_1, 370, label_width, label_height));
        panel2.add(jLabel21, new AbsoluteConstraints(label_x_2, 370, label_width1, label_height));
        panel2.add(jLabel22, new AbsoluteConstraints(label_x_1, 405, label_width, label_height));
        panel2.add(jComboBox2, new AbsoluteConstraints(label_x_2, 405, label_width1, label_height));
        
        ////////////////////////////////////////////// first & last five
        
        panel2.add(jLabel23, new AbsoluteConstraints(label_x_1, 440, label_width, 30));
        panel2.add(jTextPane1, new AbsoluteConstraints(label_x_2, 440, 200, 125));

        panel2.add(jLabel25, new AbsoluteConstraints(label_x_1, 570, label_width, 30));
        panel2.add(jTextPane2, new AbsoluteConstraints(label_x_2, 570, 200, 125));
        
        panel2.add(jButton2, new AbsoluteConstraints(30, 685, 185, 30));
        panel2.add(jButton3, new AbsoluteConstraints(235, 685, 185, 30));     
        
        //////----------------------------THIRD panel
        
        jComboBox3.addItemListener(new SummaryPanel_jComboBox3_itemAdapter(this));
        jLabel32.setText("Metadata Set: ");
        jLabel32.setFont(new java.awt.Font("Sans-serif", Font.BOLD, label_font_size));
        
        jLabel33.setText("Indexes");
        jLabel33.setFont(new java.awt.Font("Sans-serif", Font.BOLD, label_font_size));
        
        jLabel34.setText("Completeness");
        jLabel34.setFont(new java.awt.Font("Sans-serif", Font.BOLD, label_font_size));
        
        jButton7.setText("Statistics");
        jButton7.setBorder(BorderFactory.createLineBorder(Color.DARK_GRAY));
        ActionListener doIt7 = new ActionListener() {
		public void actionPerformed(ActionEvent ae) {
		    	jButton7_actionPerformed(ae);
			}
	    };
	
	    ActionListener cursorDoIt7 = CursorController.createListener(this, doIt7);
	    jButton7.addActionListener(cursorDoIt7);
        
        jButton6.setText("Indexs");
        jButton6.setBorder(BorderFactory.createLineBorder(Color.DARK_GRAY));
        ActionListener doIt6 = new ActionListener() {
        	public void actionPerformed(ActionEvent ae) {
        		jButton6_actionPerformed(ae);
        	}
	    };
	
	    ActionListener cursorDoIt6 = CursorController.createListener(this, doIt6);
	    jButton6.addActionListener(cursorDoIt6);
          
        jComboBox3.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 16));
      
        jList2 = new JList();
        jList2.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 16));
        
        jLabel43.setText("Hide Empty Metadata Element");
        jLabel43.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 12));
        
        jLabel44.setText("Hide Completed Metadata Element ");
        jLabel44.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 12));
        
        jLabel45.setText("Hide Document with empty metadata element set");
        jLabel45.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 12));
        
        jLabel46.setText("Hide Document with completed metadata element set");
        jLabel46.setFont(new java.awt.Font("Sans-serif", Font.BOLD, 12));
        
        jButton10.setText("Customise");
        jButton10.setPreferredSize(new Dimension(150,20));
        jButton10.setBorder(BorderFactory.createLineBorder(Color.DARK_GRAY));
        
        ActionListener doIt10 = new ActionListener() {
        	public void actionPerformed(ActionEvent ae) {
        		jButton10_actionPerformed(ae);
        	}
	    };
	
	    ActionListener cursorDoIt10 = CursorController.createListener(this, doIt10);
	    jButton10.addActionListener(cursorDoIt10);
        
        JComponent panel3 = new JPanel();
        panel3.setLayout(new AbsoluteLayout());
        panel3.add(jLabel32, new AbsoluteConstraints(label_x_1, 20, label_width1, label_height));
        panel3.add(jComboBox3, new AbsoluteConstraints(label_x_2, 20, label_width1, label_height));
        panel3.add(jLabel33, new AbsoluteConstraints(label_x_1, 80, label_width, label_height));
        panel3.add(jLabel34, new AbsoluteConstraints(250, 80, label_width1, label_height));
        panel3.add(new JScrollPane(jList2), new AbsoluteConstraints(label_x_1, 120, 450, 250));
                
        panel3.add(jButton6,new AbsoluteConstraints(50,650,100,30));
        panel3.add(jButton7,new AbsoluteConstraints(160,650,100,30));
        panel3.add(jButton10,new AbsoluteConstraints(270,650,100,30));
        
        JPanel panel5 = new JPanel();
        panel5.setLayout(new AbsoluteLayout());
        panel5.setBorder(BorderFactory.createLineBorder(Color.black));
        
        panel5.add(jLabel43,new AbsoluteConstraints(35,5,400,label_height));
        panel5.add(jLabel44,new AbsoluteConstraints(35,40,400,label_height));
        panel5.add(jLabel45,new AbsoluteConstraints(35,75,400,label_height));
        panel5.add(jLabel46,new AbsoluteConstraints(35,110,400,label_height));
        
        panel5.add(jCheckBox5,new AbsoluteConstraints(10,7,20,20));
        panel5.add(jCheckBox6,new AbsoluteConstraints(10,42,20,20));
        panel5.add(jCheckBox7,new AbsoluteConstraints(10,77,20,20));
        panel5.add(jCheckBox8,new AbsoluteConstraints(10,112,20,20));
 
        panel3.add(panel5, new AbsoluteConstraints(label_x_1, 410, 450, 150));
   
        //Add the tabbed pane to this panel.
        add(tabbedPane);

        tabbedPane.setTabLayoutPolicy(JTabbedPane.SCROLL_TAB_LAYOUT);
	
        //Add the tabbed pane to this panel.
        add(tabbedPane);
	
        //The following line enables to use scrolling tabs.
        tabbedPane.setTabLayoutPolicy(JTabbedPane.SCROLL_TAB_LAYOUT);
        tabbedPane.addTab("Overall Statistics", panel1);
        tabbedPane.addTab("Element Information", panel2);
        tabbedPane.addTab("Metadata Set", panel3);
	
        tabbedPane.setPreferredSize(new Dimension(550, 750));
        this.setPreferredSize(new Dimension(570, 750));
        //Add the tabbed pane to this panel.
        tabbedPane.setTabLayoutPolicy(JTabbedPane.SCROLL_TAB_LAYOUT);

        overallPageUpdate();
        updateSingleMetadataSetPage();
    }
    
    
    protected JComponent makeTextPanel(String text) {
        JPanel panel = new JPanel(false);
        JLabel filler = new JLabel(text);
        filler.setHorizontalAlignment(JLabel.CENTER);
        panel.setLayout(new GridLayout(1, 1));
        panel.add(filler);
        return panel;
    }
    
    // Variable declaration
    JTabbedPane tabbedPane = new JTabbedPane();
    JTable jTable1 = new JTable();
   
    String[] columnNames = {"Element","Total times element used","No. of record \ncontaining element", "Mean","Median","Unique Value","Min","Max","Avg","Mode","Mode frequency"};
    String[] sortOptions = {"ASCII","Frequency-based"};
    
    JLabel jLabel1 = new JLabel();
    JLabel jLabel2 = new JLabel();
    JLabel jLabel3 = new JLabel();
    JLabel jLabel4 = new JLabel();
    JLabel jLabel5 = new JLabel();
    JLabel jLabel6 = new JLabel();
    JLabel jLabel7 = new JLabel();
    JLabel jLabel8 = new JLabel();
    JLabel jLabel9 = new JLabel();
    JLabel jLabel10 = new JLabel();
    JLabel jLabel11 = new JLabel();
    JLabel jLabel12 = new JLabel();
    JLabel jLabel13 = new JLabel();
    JLabel jLabel14 = new JLabel();
    JLabel jLabel15 = new JLabel();
    JLabel jLabel16 = new JLabel();
    JLabel jLabel17 = new JLabel();
    JLabel jLabel18 = new JLabel();
    JLabel jLabel19 = new JLabel();
    JLabel jLabel20 = new JLabel();
    JLabel jLabel21 = new JLabel();
    JLabel jLabel22 = new JLabel();
    JLabel jLabel23 = new JLabel();
    JLabel jLabel24 = new JLabel();
    JLabel jLabel25 = new JLabel();
    JLabel jLabel26 = new JLabel();
    
    /////////////////////////// -- more
    JLabel jLabel27 = new JLabel();//left panel1
    JLabel jLabel28 = new JLabel();
    JLabel jLabel29 = new JLabel();
    JLabel jLabel30 = new JLabel();
    JLabel jLabel31 = new JLabel();
    
    JLabel jLabel35 = new JLabel(); //right
    JLabel jLabel36 = new JLabel();
    JLabel jLabel37 = new JLabel();
    JLabel jLabel38 = new JLabel();
    JButton jButton8 = new JButton();
    JButton jButton9 = new JButton();
    
    JCheckBox jCheckBox1 = new JCheckBox();
    JCheckBox jCheckBox2 = new JCheckBox();
    JCheckBox jCheckBox3 = new JCheckBox();
    JCheckBox jCheckBox4 = new JCheckBox();
    
    JLabel jLabel39 = new JLabel();
    JLabel jLabel40 = new JLabel();
    JLabel jLabel41 = new JLabel();
    JLabel jLabel42 = new JLabel();
    JButton jButton11 = new JButton();
    
    JLabel jLabel32 = new JLabel();//panel3
    JLabel jLabel33 = new JLabel();
    JLabel jLabel34 = new JLabel();
    JButton jButton6 = new JButton();
    JButton jButton7 = new JButton();

    JCheckBox jCheckBox5 = new JCheckBox();
    JCheckBox jCheckBox6 = new JCheckBox();
    JCheckBox jCheckBox7 = new JCheckBox();
    JCheckBox jCheckBox8 = new JCheckBox();
    
    JLabel jLabel43 = new JLabel();
    JLabel jLabel44 = new JLabel();
    JLabel jLabel45 = new JLabel();
    JLabel jLabel46 = new JLabel();
    JButton jButton10 = new JButton();
    
    ///////////////////////////////--more ends
    JButton jButton1 = new JButton();
    JButton jButton2 = new JButton();
    JButton jButton3 = new JButton();
    JButton jButton4 = new JButton();
    JButton jButton5 = new JButton();
    JTextPane jTextPane1 = new JTextPane(); 
    JTextPane jTextPane2 = new JTextPane(); 
    
    JTextArea jTextArea1 = new JTextArea();
    JTextArea jTextArea2 = new JTextArea();
    Color cl =Color.black;
    String[] elements;
    String[] MDS_list;
    
    JComboBox jComboBox1;
    JComboBox jComboBox2;
    JComboBox jComboBox3; 
    
    JList jList1;
    JList jList2;
    
    public void jComboBox1_itemStateChanged(ItemEvent e) {
	jLabel21.setText(data_Maker.getTotalDocNumber()+"");
	update(jComboBox1.getSelectedItem().toString(),jComboBox2.getSelectedItem().toString());
	FirstAndLastFive(jComboBox1.getSelectedItem().toString(),jComboBox2.getSelectedItem().toString());
    }
    
    public void jComboBox2_itemStateChanged(ItemEvent e) {
    	FirstAndLastFive(jComboBox1.getSelectedItem().toString(),jComboBox2.getSelectedItem().toString());
    }
    
    public void jComboBox3_itemStateChanged(ItemEvent e) {
    	updateSingleMetadataSetPage();
    }
    
    private void updateSingleMetadataSetPage(){
    	DataMaker dm = new DataMaker(ms_stats);
    	dm.setTotalDocNumber();

    	String mdsIndexesName = jComboBox3.getSelectedItem().toString();
    	HashMap hp = ms_stats.getMetadataSetMap();
    	MetadataSet msx = (MetadataSet)hp.get(mdsIndexesName);
    	ArrayList nameList = msx.getIndexsList();
    	String[][] MetadataData = new String[nameList.size()][2]; 
    	
    	for(int i = 0; i<nameList.size(); i++){
    		MetadataData[i][0] = (String)nameList.get(i);
    		MetadataData[i][1] = new String(dm.Mean((String)nameList.get(i))+" %");
	    
    		if(MetadataData[i][1].indexOf(".")==2){
    			MetadataData[i][1] = "  "+MetadataData[i][1];
    		}
    		else if(MetadataData[i][1].indexOf(".")==1){
    			MetadataData[i][1] = "    "+MetadataData[i][1];
    		}
    	}
	
    	jList2.setListData(MetadataData);
    	jList2.setCellRenderer(new MyCellRenderer()); 
    	jListDataModel.put("jList2",MetadataData);

    }
    
    private void FirstAndLastFive(String element_name, String sort){
    	DataMaker dm = new DataMaker(ms_stats);
    	dm.setTotalDocNumber();
    	
    	String[] temp = dm.getSortList(element_name,sort);
    	String[] temp2 = {" "," "," "," "," "};
    	int length = 0;
    	if(temp.length>=5){length=5;}
    	else if(temp.length<5){length = temp.length;}
            
    	for(int i =0; i<length; i++){
    	    temp2[i] = temp[i];
    	}

    	jTextPane1.setText("");
    	jTextPane1.setText("1. "+temp2[0]+"\n2. "+temp2[1]+"\n3. "+temp2[2]+"\n4. "+temp2[3]+"\n5. "+temp2[4]);  
    	
    	// Last five value
    	String[] temp3 = {" "," "," "," "," "};
    	length = 0;
    	int start = temp.length;
    	
	if(temp.length>=5){
	    length= 5;
	}
    	else if(temp.length<5){
	    length = temp.length;
	}
            
    	for(int i = 0; i<length; i++){
    	    temp3[i] = temp[start-1];
    	    start--;
    	}

    	jTextPane2.setText("");
    	jTextPane2.setText("1. "+temp3[0]+"\n2. "+temp3[1]+"\n3. "+temp3[2]+"\n4. "+temp3[3]+"\n5. "+temp3[4]);  
    	
    }
    
    private void overallPageUpdate(){
    	DataMaker dm = new DataMaker(ms_stats);

    	jTextArea2.setText("");
    	ArrayList wholeList = new ArrayList();
    	HashMap hp = ms_stats.getMetadataSetMap();
    	Collection c = hp.values();
    	Iterator i = c.iterator();
	int counter = 0;
    	String[][] MetadataData = new String[c.size()][2];
    	
	while(i.hasNext()){
	    MetadataSet mds  = (MetadataSet)i.next();
	    wholeList.add(mds);
	    ArrayList newMDS  = new ArrayList();
	    newMDS.add(mds);
	    MetadataData[counter][0] = mds.getName();
	    MetadataData[counter][1] = dm.getSingleMetadataSetCompleteness(newMDS)+" %";
	    counter++;
    	}
	
	jLabel35.setText(dm.getTotalDocNumber()+"");
    	jLabel36.setText(ms_stats.getMetadataSetMap().size()+"");
    	jLabel37.setText(dm.getSingleMetadataSetCompleteness(wholeList)+" %");
    	
	jList1.setListData(MetadataData);
    	jList1.setCellRenderer(new MyCellRenderer()); 
    	jListDataModel.put("jList1",MetadataData);
    }
    
    static class MyCellRenderer extends JPanel implements ListCellRenderer{ 
        JLabel left, middle, right; 
        MyCellRenderer() { 
	    setLayout(new GridLayout(1, 2)); 
	    left = new JLabel(); 
	    
	    right = new JLabel(); 
	    left.setOpaque(true); 
	    
	    right.setOpaque(true); 
	    add(left); 
	    add(right); 
        } 
	
        public Component getListCellRendererComponent(JList list,Object value,int index,boolean isSelected,boolean cellHasFocus){ 
	    String leftData    = ((String[])value)[0]; 
	    String rightData    = ((String[])value)[1]; 
	    left.setText(leftData); 
	    right.setText(rightData);
	    
	    if(isSelected){ 
		left.setBackground(list.getSelectionBackground()); 
		left.setForeground(list.getSelectionForeground()); 
		right.setBackground(list.getSelectionBackground()); 
		right.setForeground(list.getSelectionForeground()); 
	    } 
	    
	    else{ 
		left.setBackground(list.getBackground()); 
		left.setForeground(list.getForeground()); 
		right.setBackground(list.getBackground()); 
		right.setForeground(list.getForeground()); 
	    } 
	    
	    setEnabled(list.isEnabled()); 
	    setFont(list.getFont()); 
	    return this; 
        } 
    }
    
    private void update(String element_name, String sort){
	DataMaker dm = new DataMaker(ms_stats);
	dm.setTotalDocNumber();
	
	jLabel3.setText(dm.getDistinctNumber(element_name)+"");
	jLabel5.setText(dm.getFrequency(element_name)+"");
	jLabel7.setText(dm.getDocumentUsedElement(element_name)+"");
	jLabel9.setText(dm.Mean(element_name)+"");
	jLabel11.setText(dm.Median(element_name)+"");
	jLabel13.setText(dm.getMinRange(element_name)+"");
	jLabel15.setText(dm.getMaxRange(element_name)+"");
	jLabel17.setText(dm.Average(element_name)+"");
	jLabel19.setText(dm.getMode(element_name)+"");
	jLabel21.setText(dm.ModeFrequency(element_name)+"");
    }	
    
    public void jButton1_actionPerformed(ActionEvent actionevent) {
	
	ArrayList alist = new ArrayList();
    	
	for(int a = 0; a<elements.length; a++){
	    alist.add(data_Maker.getMetadataRows(elements[a]));
    	}
	
    	String[] ids = data_Maker.getDocumentIDs("archivedir");
    	new DrawSymbolAxis("Total Document: "+totalDocument +" Total Element:"+totalMetadataElement + " Total Metadata Item:"+totalMetadataItem,elements,ids,alist);
    }
    
    
    public void jButton2_actionPerformed(ActionEvent actionevent) {
    	
	String item = jComboBox1.getSelectedItem().toString();
    	new DrawXYChart("",item,data_Maker.getDistinctValueMap(item),1);
    }
    
    public void jButton3_actionPerformed(ActionEvent actionevent) {
    	String item = jComboBox1.getSelectedItem().toString();
    	new DrawXYChart("",item,data_Maker.getDocFrequencyMap(item),2);
    }
    
    public void jButton6_actionPerformed(ActionEvent actionevent) {
    	
	String mdsName = jComboBox3.getSelectedItem().toString();
    	HashMap hp = ms_stats.getMetadataSetMap();
    	MetadataSet msx = (MetadataSet)hp.get(mdsName);
    	ArrayList al = msx.getIndexsList();
    	String[] tempx = new String[al.size()];
     	
    	for(int a = 0; a<al.size(); a++){
    		tempx[a] = (String)al.get(a);
    	}
    	
    	ArrayList alist = new ArrayList();
    	
	for(int a = 0; a<tempx.length; a++){
	    alist.add(data_Maker.getMetadataRows(tempx[a]));
    	}
    	
    	String[] ids = data_Maker.getDocumentIDs("archivedir");
    	int totalDoc = ids.length;
    	int totalElement = tempx.length;
    	int totalItem = totalDoc * totalElement;
    	new DrawSymbolAxis("Total Document: "+ totalDoc +" Total Element:"+totalElement  + " Total Metadata Item:"+totalItem,tempx,ids,alist);
    }
    
    public void jButton7_actionPerformed(ActionEvent actionevent) {
    	
    	DataMaker dm = new DataMaker(ms_stats);
    	String mdsName = jComboBox3.getSelectedItem().toString();
    	HashMap hp = ms_stats.getMetadataSetMap();
    	MetadataSet mds = (MetadataSet)hp.get(mdsName);
    	ArrayList alist = mds.getIndexsList();
    	Object[][] dataset = dm.getMetadataInfo(mds);
    	new MetadataTable(columnNames,dataset);
    }
    
    public void jButton8_actionPerformed(ActionEvent actionevent) {
    	
	DataMaker dm = new DataMaker(ms_stats);
    	Object[][] dataset = dm.AllInformation();
    	new MetadataTable(columnNames,dataset);
    }
    
    public void jButton9_actionPerformed(ActionEvent actionevent) {
    	
	DataMaker dm = new DataMaker(ms_stats);
    	String[] metaDataElementName = (String[])elements.clone();	
	String[] ids = data_Maker.getDocumentIDs("archivedir");
	ArrayList alist = new ArrayList();
    	
	for(int a = 0; a<elements.length; a++){
	    alist.add(data_Maker.getMetadataRows(elements[a]));
    	}
    	
    	int totalDocx = ids.length;
    	int totalElementx = elements.length;
    	int totalItemx = totalDocx * totalElementx;
    	
    	if(jCheckBox1.isSelected() == false && jCheckBox2.isSelected() == false && jCheckBox3.isSelected() == false && jCheckBox4.isSelected() == false){
    		new DrawSymbolAxis("Total Document: "+ totalDocx +" Total Element:"+totalElementx  + " Total Metadata Item:"+totalItemx,elements,ids,alist);
    	}
    	
    	else{
    	ArrayList nameList = new ArrayList();
    	
	if(jCheckBox1.isSelected() == true){
	    alist = new ArrayList();
	    nameList = new ArrayList();
    		
	    for(int i = 0; i< metaDataElementName.length; i++){
    		if(!dm.IsElementEmpty(metaDataElementName[i])){
		    alist.add(data_Maker.getMetadataRows(metaDataElementName[i]));
		    nameList.add(metaDataElementName[i]);
		}
	    }
	    
	    metaDataElementName = new String[nameList.size()];
	    for(int i = 0; i< nameList.size(); i++){
		metaDataElementName[i] = nameList.get(i).toString();
	    }
	}
    	
    	if(jCheckBox2.isSelected() == true){
	    alist = new ArrayList();
	    nameList = new ArrayList();
	    
	    for(int i = 0; i< metaDataElementName.length; i++){
		if(!dm.IsElementFull(metaDataElementName[i])){
		    alist.add(data_Maker.getMetadataRows(metaDataElementName[i]));
		    nameList.add(metaDataElementName[i]);
		}
	    }
	    metaDataElementName = new String[nameList.size()];
	    for(int i = 0; i< nameList.size(); i++){
		metaDataElementName[i] = nameList.get(i).toString();
	    }
	}
    	
    	if(jCheckBox3.isSelected() == true){
	    alist = data_Maker.removeDocument(alist, ids, 0);
	    ArrayList idList = data_Maker.getRemovedID();
	    ArrayList newIDList = new ArrayList();
	    
	    for(int i = 0; i< ids.length; i++){
		if(!idList.contains(ids[i])){
		    newIDList.add(ids[i]);
		}
	    }
	    ids = new String[newIDList.size()];
	  
	    for(int i = 0; i<newIDList.size(); i++){
		ids[i] = newIDList.get(i).toString();
	    }
	}
    	
    	if(jCheckBox4.isSelected() == true){
	    alist = data_Maker.removeDocument(alist, ids ,1);
	    ArrayList idList = data_Maker.getRemovedID();
	    ArrayList newIDList = new ArrayList();
	    
	    for(int i = 0; i< ids.length; i++){
		if(!idList.contains(ids[i])){
		    newIDList.add(ids[i]);
		}
	    }
	    
	    ids = new String[newIDList.size()];
	    for(int i = 0; i<newIDList.size(); i++){
		ids[i] = newIDList.get(i).toString();
	    }
	}
    	
    	
    	totalDocx = ids.length;
    	totalElementx = metaDataElementName.length;
    	totalItemx = totalDocx * totalElementx;
    	new DrawSymbolAxis("Total Document: "+ totalDocx +" Total Element:"+totalElementx  + " Total Metadata Item:"+totalItemx,metaDataElementName,ids,alist);
    	}
    }
    
    
    public void jButton10_actionPerformed(ActionEvent actionevent) {
	
	DataMaker dm = new DataMaker(ms_stats);
    String elemenetName = jComboBox3.getSelectedItem().toString();

    HashMap elementMap = ms_stats.getMetadataSetMap();
    MetadataSet elementSet = (MetadataSet)elementMap.get(elemenetName);
	
    ArrayList alist2 = elementSet.getIndexsList();
    	String[] metaDataElementName = new String[alist2.size()];
    	
	for(int i = 0; i< alist2.size(); i++){
	    metaDataElementName[i] = alist2.get(i).toString();
	    //System.out.println(metaDataElementName[i]);
    }
    	
	String[] ids = data_Maker.getDocumentIDs("archivedir");
	ArrayList alist = new ArrayList();
    	
		for(int a = 0; a<metaDataElementName.length; a++){
			alist.add(data_Maker.getMetadataRows(metaDataElementName[a]));
			System.out.println("Metadata Element: "+metaDataElementName[a]);
    	}
		
    	if(jList2.getSelectedIndices().length>0){
	    int[] location = jList2.getSelectedIndices();
	    String[][] list = (String[][])jListDataModel.get("jList2");
	    metaDataElementName = new String[location.length];
	    //System.out.println(jList2.size());
	    for(int i = 0; i< location.length; i++){
		int x = location[i];
		metaDataElementName[i] = list[x][0];
		//System.out.println(metaDataElementName[i]);
	    }
	    ids = data_Maker.getDocumentIDs("archivedir");
	}
    	
    	int totalDocx = ids.length;
    	int totalElementx = metaDataElementName.length;
    	int totalItemx = totalDocx * totalElementx;
    	
    	if(jCheckBox5.isSelected() == false && jCheckBox6.isSelected() == false && jCheckBox7.isSelected() == false && jCheckBox8.isSelected() == false){
    		new DrawSymbolAxis("Total Document: "+ totalDocx +" Total Element:"+totalElementx  + " Total Metadata Item:"+totalItemx,metaDataElementName,ids,alist);
    	}
    	
    	else{

    	ArrayList nameList = new ArrayList();
    	
    	if(jCheckBox5.isSelected() == true){
	    alist = new ArrayList();
	    nameList = new ArrayList();
	    
	    for(int i = 0; i< metaDataElementName.length; i++){
		if(!dm.IsElementEmpty(metaDataElementName[i])){
		    alist.add(data_Maker.getMetadataRows(metaDataElementName[i]));
		    nameList.add(metaDataElementName[i]);
		}
	    }
	    
	    metaDataElementName = new String[nameList.size()];
	    
	    for(int i = 0; i< nameList.size(); i++){
		metaDataElementName[i] = nameList.get(i).toString();
	    }
	}
    	
    	if(jCheckBox6.isSelected() == true){
	    alist = new ArrayList();
	    nameList = new ArrayList();
	    
	    for(int i = 0; i< metaDataElementName.length; i++){
		if(!dm.IsElementFull(metaDataElementName[i])){
		    alist.add(data_Maker.getMetadataRows(metaDataElementName[i]));
		    nameList.add(metaDataElementName[i]);
		}
	    }
	    metaDataElementName = new String[nameList.size()];
    		
	    for(int i = 0; i< nameList.size(); i++){
		metaDataElementName[i] = nameList.get(i).toString();
	    }
	}
    	
    	if(jCheckBox7.isSelected() == true){
	    alist = data_Maker.removeDocument(alist, ids , 0);
	    ArrayList idList = data_Maker.getRemovedID();
	    ArrayList newIDList = new ArrayList();
    		
	    for(int i = 0; i< ids.length; i++){
		if(!idList.contains(ids[i])){
		    newIDList.add(ids[i]);
		}
	    }
	    ids = new String[newIDList.size()];
	    
	    for(int i = 0; i<newIDList.size(); i++){
		ids[i] = newIDList.get(i).toString();
	    }
	}
    	
    	if(jCheckBox8.isSelected() == true){
	    alist = data_Maker.removeDocument(alist, ids , 1);
	    ArrayList idList = data_Maker.getRemovedID();
	    ArrayList newIDList = new ArrayList();
    		
	    for(int i = 0; i< ids.length; i++){
		if(!idList.contains(ids[i])){
		    newIDList.add(ids[i]);
		}
	    }
	    ids = new String[newIDList.size()];
	    
	    for(int i = 0; i<newIDList.size(); i++){
		ids[i] = newIDList.get(i).toString();
	    }
	}
    	
    	totalDocx = ids.length;
    	totalElementx = metaDataElementName.length;
    	totalItemx = totalDocx * totalElementx;
    	
    	new DrawSymbolAxis("Total Document: "+ totalDocx +" Total Element:"+totalElementx  + " Total Metadata Item:"+totalItemx,metaDataElementName,ids,alist);
    	}
    }
}	


class SummaryPanel_jComboBox1_itemAdapter implements ItemListener {
    private SummaryPanel adaptee;
    SummaryPanel_jComboBox1_itemAdapter(SummaryPanel adaptee) {
        this.adaptee = adaptee;
    }
    
    public void itemStateChanged(ItemEvent e) {
        adaptee.jComboBox1_itemStateChanged(e);
    }
}

class SummaryPanel_jComboBox2_itemAdapter implements ItemListener {
    private SummaryPanel adaptee;
    SummaryPanel_jComboBox2_itemAdapter(SummaryPanel adaptee) {
        this.adaptee = adaptee;
    }
    
    public void itemStateChanged(ItemEvent e) {
        adaptee.jComboBox2_itemStateChanged(e);
    }
}

class SummaryPanel_jComboBox3_itemAdapter implements ItemListener {
    private SummaryPanel adaptee;
    SummaryPanel_jComboBox3_itemAdapter(SummaryPanel adaptee) {
        this.adaptee = adaptee;
    }
    
    public void itemStateChanged(ItemEvent e) {
        adaptee.jComboBox3_itemStateChanged(e);
    }
}

class SummaryPanel_jButton1_Adapter implements ActionListener {
    private SummaryPanel adaptee;
    SummaryPanel_jButton1_Adapter(SummaryPanel adaptee) {
        this.adaptee = adaptee;
    }
    
    public void actionPerformed(ActionEvent e) {
        adaptee.jButton1_actionPerformed(e);
    }
}

class SummaryPanel_jButton2_Adapter implements ActionListener {
    private SummaryPanel adaptee;
    SummaryPanel_jButton2_Adapter(SummaryPanel adaptee) {
        this.adaptee = adaptee;
    }
    
    public void actionPerformed(ActionEvent e) {
        adaptee.jButton2_actionPerformed(e);
    }
}

class SummaryPanel_jButton3_Adapter implements ActionListener {
    private SummaryPanel adaptee;
    SummaryPanel_jButton3_Adapter(SummaryPanel adaptee) {
        this.adaptee = adaptee;
    }
    
    public void actionPerformed(ActionEvent e) {
        adaptee.jButton3_actionPerformed(e);
    }
}

class SummaryPanel_jButton6_Adapter implements ActionListener {
    private SummaryPanel adaptee;
    SummaryPanel_jButton6_Adapter(SummaryPanel adaptee) {
        this.adaptee = adaptee;
    }
    
    public void actionPerformed(ActionEvent e) {
        adaptee.jButton6_actionPerformed(e);
    }
}

class SummaryPanel_jButton7_Adapter implements ActionListener {
    private SummaryPanel adaptee;
    SummaryPanel_jButton7_Adapter(SummaryPanel adaptee) {
        this.adaptee = adaptee;
    }
    
    public void actionPerformed(ActionEvent e) {
        adaptee.jButton7_actionPerformed(e);
    }
}

class SummaryPanel_jButton8_Adapter implements ActionListener {
    private SummaryPanel adaptee;
    SummaryPanel_jButton8_Adapter(SummaryPanel adaptee) {
        this.adaptee = adaptee;
    }
    
    public void actionPerformed(ActionEvent e) {
        adaptee.jButton8_actionPerformed(e);
    }
}

class SummaryPanel_jButton9_Adapter implements ActionListener {
    private SummaryPanel adaptee;
    SummaryPanel_jButton9_Adapter(SummaryPanel adaptee) {
        this.adaptee = adaptee;
    }
    
    public void actionPerformed(ActionEvent e) {
        adaptee.jButton9_actionPerformed(e);
    }
}

class SummaryPanel_jButton10_Adapter implements ActionListener {
    private SummaryPanel adaptee;
    SummaryPanel_jButton10_Adapter(SummaryPanel adaptee) {
        this.adaptee = adaptee;
    }
    
    public void actionPerformed(ActionEvent e) {
        adaptee.jButton10_actionPerformed(e);
    }
}

/*
class SummaryPanel_jButton11_Adapter implements ActionListener {
    private SummaryPanel adaptee;
    SummaryPanel_jButton11_Adapter(SummaryPanel adaptee) {
        this.adaptee = adaptee;
    }
    
    public void actionPerformed(ActionEvent e) {
        adaptee.jButton11_actionPerformed(e);
    }
}
*/